$Id: checklink.pod,v 1.14 2006/06/15 17:53:14 ville Exp $

=head1 NAME

checklink - check the validity of links in an HTML or XHTML document

=head1 SYNOPSIS

B<checklink>  [ I<options> ] I<uri> ...

=head1 DESCRIPTION

This manual page documents briefly the B<checklink> command, a.k.a. the
W3C® Link Checker.

B<checklink> is a program that reads an HTML or XHTML document,
extracts a list of anchors and lists and checks that no anchor is
defined twice and that all the links are dereferenceable, including
the fragments. It warns about HTTP redirects, including directory
redirects, and can check recursively a part of a web site.

The program can be used either as a command line tool or as a CGI script.

=head1 OPTIONS

This program follow the usual GNU command line syntax, with long options
starting with two dashes (`-'). A summary of options is included below.

=over 5

=item B<-?, -h, --help>

Show summary of options.

=item B<-V, --version>

Output version information.

=item B<-s, --summary>

Show result summary only.

=item B<-b, --broken>

Show only the broken links, not the redirects.

=item B<-e, --directory>

Hide directory redirects - e.g. L<http://www.w3.org/TR> ->
L<http://www.w3.org/TR/>.

=item B<-r, --recursive>

Check the documents linked from the first one.

=item B<-D, --depth> I<n>

Check the documents linked from the first one to depth I<n>
(implies B<--recursive>).

=item B<-l, --location> I<uri>

Scope of the documents checked (implies B<--recursive>).
Can be specified multiple times in order to specify multiple recursion
bases.  If the URI of a candidate document is downwards relative to any of
the bases, it is considered to be within the scope.  If not specified, the
default is the base URI of the initial document, for example for
L<http://www.w3.org/TR/html4/Overview.html> it would be
L<http://www.w3.org/TR/html4/>.

=item B<--exclude-docs> I<regexp>

In recursive mode, do not check links in documents whose URIs match
I<regexp>.

=item B<-L, --languages> I<accept-language>

The C<Accept-Language> HTTP header to send.  In command line mode,
this header is not sent by default.  The special value C<auto> causes
a value to be detected from the C<LANG> environment variable, and sent
if found.  In CGI mode, the default is to send the value received from
the client as is.

=item B<-q, --quiet>

No output if no errors are found.

=item B<-v, --verbose>

Verbose mode.

=item B<-i, --indicator>

Show progress while parsing.

=item B<-u, --user> I<username>

Specify a username for authentication.

=item B<-p, --password> I<password>

Specify a password for authentication.

=item B<--hide-same-realm>

Hide 401's that are in the same realm as the document checked.

=item B<-S, --sleep> I<secs>

Sleep the specified number of seconds between requests to each server.
Defaults to 1 second, which is also the minimum allowed.

=item B<-t, --timeout> I<secs>

Timeout for requests, in seconds.

=item B<-d, --domain> I<domain>

Perl regular expression describing the domain to which the authentication
information (if present) will be sent.  The default value can be specified
in the configuration file.  See the C<Trusted> entry in the configuration
file description below for more information.

=item B<--masquerade> I<"local remote">

Masquerade local dir as a remote URI.  For example, the following results in
/my/local/dir/ being "mapped" to http://some/remote/uri/

  --masquerade "/my/local/dir http://some/remote/uri/"

As of revision 3.6.2.19 of checklink, B<--masquerade> takes a single
argument consisting of two URIs, separated by whitespace.  One usual way of
providing a value with embedded whitespace is to enclose it in quotes.

=item B<-H, --html>

HTML output.

=back

=head1 FILES

=over 5

=item F</etc/w3c/checklink.conf>

The main configuration file.  You can use the L<W3C_CHECKLINK_CFG> environment
variable to override the default location.

C<Trusted> specifies a regular expression for matching trusted domains
(ie. domains where HTTP basic authentication, if any, will be sent).
The regular expression will be matched case insensitively against host
names.  The default behavior (when unset, that is) is to send the
authentication information only to the host which requests it; usually
you don't want to change this.  For example, the following configures
I<only> the w3.org domain as trusted:

    Trusted = \.w3\.org$

C<Allow_Private_IPs> is a boolean flag indicating whether checking links
on non-public IP addresses is allowed.  The default is true in command line
mode and false when run as a CGI script.  For example, to disallow checking
non-public IP addresses, regardless of the mode, use:

   Allow_Private_IPs = 0

C<Markup_Validator_URI> and C<CSS_Validator_URI> are formatted URIs to the
respective validators.  The C<%s> in these will be replaced with the full
"URI encoded" URI to the document being checked, and shown in the link
checker results view in the online/CGI version.  The defaults are:

   Markup_Validator_URI =
     http://validator.w3.org/check?uri=%s
   CSS_Validator_URI =
     http://jigsaw.w3.org/css-validator/validator?uri=%s

C<Doc_URI> and C<Style_URI> are URIs used for linking to the documentation
and style sheet from the dynamically generated content of the link checker.
The defaults are:

   Doc_URI = http://validator.w3.org/docs/checklink.html
   Style_URI = http://validator.w3.org/docs/linkchecker.css

=back

=head1 ENVIRONMENT

checklink uses the libwww-perl library which has a number of environment
variables affecting its behaviour.  See L</"SEE ALSO"> for some
pointers.

=over 5

=item B<W3C_CHECKLINK_CFG>

If set, overrides the path to the configuration file.

=back

=head1 SEE ALSO

The documentation for this program is available on the web at
L<http://validator.w3.org/docs/checklink.html>.

L<LWP>, L<Net::FTP>, L<Net::NNTP>, L<Net::IP>, L<perlre>.

=head1 AUTHOR

This program was originally written by Hugo Haas E<lt>hugo@w3.orgE<gt>, based
on Renaud Bruyeron's F<checklink.pl>.  It has been enhanced by Ville Skyttä
and many other volunteers since.  Use the E<lt>www-validator@w3.orgE<gt>
mailing list for feedback, and see
L<http://validator.w3.org/docs/checklink.html#csb> for more information.

This manual page was written by Frédéric Schütz <schutz@mathgen.ch>
for the Debian GNU/Linux system (but may be used by others).

=head1 COPYRIGHT

This program is licensed under the W3C® Software License,
L<http://www.w3.org/Consortium/Legal/copyright-software>.

=cut
